import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { YRKEN } from '@msfa-constants/yrken';
import { ErrorType } from '@msfa-enums/error-type.enum';
import { environment } from '@msfa-environment';
import { SlutredovisningRequest } from '@msfa-models/api/slutredovisning.request.model';
import { SlutredovisningResponse } from '@msfa-models/api/slutredovisning.response.model';
import { YrkesomradeResponse } from '@msfa-models/api/yrkesomrade.response.model';
import { CustomError } from '@msfa-models/error/custom-error';
import { Observable, of } from 'rxjs';
import { catchError } from 'rxjs/operators';

@Injectable({
  providedIn: 'root',
})
export class SlutredovisningApiService {
  private _apiBaseUrl = `${environment.api.url}/rapporter/slutredovisning`;
  private _handlingarBaseUrl = `${environment.api.url}/handlingar`;

  constructor(private httpClient: HttpClient) {}

  public fetchYrken$(): Observable<{ data: YrkesomradeResponse[] }> {
    return of({ data: YRKEN });
  }

  public fetchSlutredovisning$(handlingId: string): Observable<{ data: SlutredovisningResponse }> {
    return this.httpClient.get<{ data: SlutredovisningResponse }>(
      `${this._handlingarBaseUrl}/slutredovisning/${handlingId}`
    );
  }

  public submitSlutredovisning$(requestData: SlutredovisningRequest): Observable<void> {
    return this.httpClient.post<void>(`${this._apiBaseUrl}`, requestData).pipe(
      catchError((error: Error) => {
        throw new CustomError({
          error,
          message: `Kunde inte spara Periodisk redovisning.\n\n${error.message}`,
          type: ErrorType.API,
        });
      })
    );
  }
}
